#ifndef QUEUES_H
#define QUEUES_H
#include <pthread.h>
typedef struct {
    pthread_mutex_t *mtx;
    pthread_cond_t *cond;
    void **buf;
    int buflen,p,k;
} queue_s;

extern unsigned int queue_len(queue_s *q);
extern void init_queue(queue_s *q);
extern void queue_put(queue_s *q, void *p);
extern void *queue_index(queue_s *q,unsigned int i);
extern void queue_remove_index(queue_s *q,unsigned int i);
extern void *queue_get(queue_s *q);
extern void *queue_get_wait(queue_s *q);
extern void *queue_get_timedwait(queue_s *q, int msecs);
#endif
